# $description: Save CIF for LW
# $show-in-menu
#Script to save and hopefully process saved file so that laser writer software is happy
#empty is string directs to current directory
file_name=RBA::FileDialog.ask_save_file_name("Save CIF File for LaserWriter","","CIF (*.cif)")
slo=RBA::SaveLayoutOptions.new
#need to set up for for cif file and correct units
slo.format="CIF"
mw = RBA::Application::instance.main_window
#method to save file
currentLayout=RBA::LayoutView::current
begin
currentLayout.save_as(mw.current_view_index,file_name,slo)
rescue
else
units=RBA::CellView::active.layout.dbu
#I just noticed the CleWin file was saved with units of 0.001, and this is not true for y
#original KLayout. This might be another compatibility issue
#Also the DS commands (definition start) have different scaling factors
cifFile=File.open(file_name,'r') do |file|
#This is not neccesary but makes sure file will be closed
cifText=File.readlines(file_name)
end
#cifText=cifText.drop(0)
File.open(file_name,'w') do |file|
cifText[0]= "(CIF written by CleWin 4.1);\n(1 unit = #{units} micron);\n(Center for Nanoscience and);
(Nanotechnology);\n(The Hebrew University of Jerusalem);\n(Jerusalem, Israel);\n(Layer names:);\n"
cifText.each {|i| file.puts((i).gsub(","," "))}
end
end